#include <stdio.h>
#include <malloc.h>
#include "numeric2.h"

int main(int argc, char* argv[]) {
	int i;

	char* pause = (char*) malloc(1000);
	numeric2 one = numeric2_allocate(1, 1, 0);
	numeric2 n1234567 = numeric2_allocate(1, 1, 0);
	numeric2 big = numeric2_allocate(1, 1, 0);
	numeric2 n32 = numeric2_allocate(1, 1, 0);
	numeric2 bigbig;
	numeric2 x, y, z;
	getNumericValues(one)[0] = 1;
	getNumericValues(n1234567)[0] = 1234567;
	getNumericValues(big)[0] = 0xffffffff;

	numeric2_out(one);

	printf("1 -> %s\n", numeric2_out(one));
	printf("n2 -> %s\n", numeric2_out(n1234567));
	printf("1 + n2 -> %s\n", numeric2_out(numeric2_add(one, n1234567)));
	printf("big -> %s\n", numeric2_out(big));
	bigbig = numeric2_add(big, big);
	printf("big + big -> %s\n", numeric2_out(bigbig));

	
	getNumericValues(n32)[0] = 32;
	
	bigbig = numeric2_add(big, big);

	//__numeric2_div_and_remineder_by_component(getNumericValues(bigbig), getNumericValuesLength(bigbig));
	printf("1/10 = %s\n", numeric2_out(numeric2_div_component(__numeric2_negate(one), 10, 1)));

	//x = numeric2_in("1");
	//printf("%s\n", numeric2_to_string(x, 10));
	//printf("123456789 -> %s\n", numeric2_to_string(numeric2_in("123456789"), 10));
	printf("8589934590 -> %s\n", numeric2_out(numeric2_in("8589934590")));
	printf("123456789012345678901234567890 -> %s\n", numeric2_out(numeric2_in("123456789012345678901234567890")));
	printf("1234567890123456789012345678.90 -> %s\n", numeric2_out(numeric2_in("1234567890123456789012345678.90")));
	printf("-123456789012345678901234567890 -> %s\n", numeric2_out(numeric2_in("-123456789012345678901234567890")));
	printf("-123456789.012345678901234567890 -> %s\n", numeric2_out(numeric2_in("-123456789.012345678901234567890")));
	x = numeric2_in("1234567890123456789012345678.90");
	for (i=0; i < 1000; i++)
		x = numeric2_add(x, x);

	x = numeric2_in("1.2");
	y = numeric2_in("1");
	z = numeric2_add(x, y);
	printf("%s + %s = %s\n", numeric2_out(x), numeric2_out(y), numeric2_out(z));

	x = numeric2_in("100000000000000.0");
	y = numeric2_in("1.1111111111111111111111111111111111");
	z = numeric2_add(x, y);
	printf("%s + %s = %s\n", numeric2_out(x), numeric2_out(y), numeric2_out(z));

	x = numeric2_in("1.233");
	y = numeric2_in("0.0000000000000");
	z = numeric2_add(x, y);
	printf("%s + %s = %s\n", numeric2_out(x), numeric2_out(y), numeric2_out(z));

	x = numeric2_in("1.233");
	y = numeric2_in("0.1111");
	z = numeric2_add(x, y);
	printf("%s + %s = %s\n", numeric2_out(x), numeric2_out(y), numeric2_out(z));

	x = numeric2_in("0.9999999999999999");
	y = numeric2_in("0.0000000000000001");
	z = numeric2_add(x, y);
	printf("%s + %s = %s\n", numeric2_out(x), numeric2_out(y), numeric2_out(z));
	printf("%s\n", numeric2_out(x));
	scanf("%s", pause);

	//Memory leaks test
	while(1) {
		numeric2 n = numeric2_in("12345678901234567890123456789012345678901234567890123456789012345678901234567890");
		numeric2 s = numeric2_add(n, n);
		free(n);
		free(s);
	}
	return 0;
}