CREATE TYPE numeric2;

CREATE FUNCTION numeric2_in(cstring) RETURNS numeric2 AS
	'libnumeric2.so' LANGUAGE C STRICT ;

CREATE FUNCTION numeric2_out(numeric2) RETURNS cstring AS
	'libnumeric2.so' LANGUAGE C STRICT ;

CREATE TYPE numeric2(
	input = numeric2_in,
	output = numeric2_out,
	--alignment = double
	INTERNALLENGTH = VARIABLE,
--	ALIGNMENT = 4,
	STORAGE = plain
	);
